from actor import *
from sprite import *
from button import *

class Button(Actor):
	"""Button class"""
	
	def __init__( self, x, y, level, color, door = None ):
		super( Button, self ).__init__( x, y, level, None )
		self.pressed = False
		self.color = color
		self.door = door
	
	def is_pressed( self ):
		return self.pressed
	
	def isbutton(self):
		return False
	
	def press( self ):
		self.pressed = True
		if self.door is not None:
			self.door.open()
			
	def render(self, images, screen):
		if self.color == "Red":
			if self.pressed:
				screen.blit(images[Sprite.RED_BUTTON_PRESSED], (self.x, self.y, TILESIZE, TILESIZE))
			else:
				screen.blit(images[Sprite.RED_BUTTON], (self.x, self.y, TILESIZE, TILESIZE))
		elif self.color == "Yellow":
			if self.pressed:
				screen.blit(images[Sprite.YELLOW_BUTTON_PRESSED], (self.x, self.y, TILESIZE, TILESIZE))
			else:
				screen.blit(images[Sprite.YELLOW_BUTTON], (self.x, self.y, TILESIZE, TILESIZE))
		elif self.color == "Blue":
			if self.pressed:
				screen.blit(images[Sprite.BLUE_BUTTON_PRESSED], (self.x, self.y, TILESIZE, TILESIZE))
			else:
				screen.blit(images[Sprite.BLUE_BUTTON], (self.x, self.y, TILESIZE, TILESIZE))

