
import sys,pygame

from level import *
from math import *
from player import *

DRAW_BACKGROUND = True
#FLAGS = 0
FLAGS = pygame.FULLSCREEN

pygame.init()

def center(obj, y, dimensions):
	temprect = obj.get_rect()
	tempwidth = temprect.width
	temprect.move_ip(dimensions[0] / 2 - tempwidth / 2, y)
	return temprect

class Game(object):
	def __init__(self):
		self.size = self.width, self.height = 1024, 768
		self.background = 0, 0, 0
		
		self.menu_highlight = (145, 199, 240)
		self.menu_normal = (100, 100, 140)
		self.screen = pygame.display.set_mode(self.size, FLAGS)
		
		self.arial_path = pygame.font.match_font("arial", True)
		self.arial72 = pygame.font.Font(self.arial_path, 72)
		self.arial36 = pygame.font.Font(self.arial_path, 36)
		self.title = self.arial72.render("Graviphone", True, (255, 255, 255))
		self.newgame = self.arial36.render("New Game", True, self.menu_highlight)
		self.loadlevel = self.arial36.render("Load Level", True, self.menu_normal)
		self.quitgame = self.arial36.render("Quit Game", True, self.menu_normal)
		
		self.title_rect = center(self.title, 50, self.size)
		self.newgame_rect = center(self.newgame, 300, self.size)
		self.loadlevel_rect = center(self.loadlevel, 360, self.size)
		self.quitgame_rect = center(self.quitgame, 420, self.size)
		
		self.current_selection = self.newgame
		
		self.levelrenderer = None
		self.player = None
		
		self.images = { }
		self.images[Sprite.GRAY_BLOCK] = pygame.image.load("art/block_gray.png").convert(self.screen)
		self.images[Sprite.GRAY_BLOCK].set_colorkey((255, 0, 255))
		self.images[Sprite.BLUE_BLOCK] = pygame.image.load("art/block_blue.png").convert(self.screen)
		self.images[Sprite.BLUE_BLOCK].set_colorkey((255, 0, 255))
		self.images[Sprite.RED_BLOCK] = pygame.image.load("art/block_red.png").convert(self.screen)
		self.images[Sprite.RED_BLOCK].set_colorkey((255, 0, 255))
		self.images[Sprite.YELLOW_BLOCK] = pygame.image.load("art/block_yellow.png").convert(self.screen)
		self.images[Sprite.YELLOW_BLOCK].set_colorkey((255, 0, 255))
		self.images[Sprite.PROTAGONIST_LEFT] = pygame.image.load("art/protagonist_left.png").convert(self.screen)
		self.images[Sprite.PROTAGONIST_LEFT].set_colorkey((255, 0, 255))
		self.images[Sprite.PROTAGONIST_JUMP_RIGHT] = pygame.image.load("art/protagonist_jump.png").convert(self.screen)
		self.images[Sprite.PROTAGONIST_JUMP_RIGHT].set_colorkey((255, 0, 255))
		self.images[Sprite.PROTAGONIST_JUMP_LEFT] = pygame.image.load("art/protagonist_jump_left.png").convert(self.screen)
		self.images[Sprite.PROTAGONIST_JUMP_LEFT].set_colorkey((255, 0, 255))
		self.images[Sprite.PROTAGONIST_LIFT] = pygame.image.load("art/protagonist_lift.png").convert(self.screen)
		self.images[Sprite.PROTAGONIST_LIFT].set_colorkey((255, 0, 255))
		self.images[Sprite.PROTAGONIST_RIGHT] = pygame.image.load("art/protagonist.png").convert(self.screen)
		self.images[Sprite.PROTAGONIST_RIGHT].set_colorkey((255, 0, 255))
		self.images[Sprite.DOOR] = pygame.image.load("art/door.png").convert(self.screen)
		self.images[Sprite.DOOR].set_colorkey((255, 0, 255))
		self.images[Sprite.DOOR_LOCK] = pygame.image.load("art/door_lock.png").convert(self.screen)
		self.images[Sprite.DOOR_LOCK].set_colorkey((255, 0, 255))
		self.images[Sprite.KEY] = pygame.image.load("art/key.png").convert(self.screen)
		self.images[Sprite.KEY].set_colorkey((255, 0, 255))
		self.images[Sprite.RED_BUTTON] = pygame.image.load("art/button_red.png").convert(self.screen)
		self.images[Sprite.RED_BUTTON].set_colorkey((255, 0, 255))
		self.images[Sprite.RED_BUTTON_PRESSED] = pygame.image.load("art/button_red_pressed.png").convert(self.screen)
		self.images[Sprite.RED_BUTTON_PRESSED].set_colorkey((255, 0, 255))
		self.images[Sprite.YELLOW_BUTTON] = pygame.image.load("art/button_yellow.png").convert(self.screen)
		self.images[Sprite.YELLOW_BUTTON].set_colorkey((255, 0, 255))
		self.images[Sprite.YELLOW_BUTTON_PRESSED] = pygame.image.load("art/button_yellow_pressed.png").convert(self.screen)
		self.images[Sprite.YELLOW_BUTTON_PRESSED].set_colorkey((255, 0, 255))
		self.images[Sprite.BLUE_BUTTON] = pygame.image.load("art/button_blue.png").convert(self.screen)
		self.images[Sprite.BLUE_BUTTON].set_colorkey((255, 0, 255))
		self.images[Sprite.BLUE_BUTTON_PRESSED] = pygame.image.load("art/button_blue_pressed.png").convert(self.screen)
		self.images[Sprite.BLUE_BUTTON_PRESSED].set_colorkey((255, 0, 255))
		self.images[Sprite.RED_DOOR] = pygame.image.load("art/door_red.png").convert(self.screen)
		self.images[Sprite.RED_DOOR].set_colorkey((255, 0, 255))
		self.images[Sprite.YELLOW_DOOR] = pygame.image.load("art/door_yellow.png").convert(self.screen)
		self.images[Sprite.YELLOW_DOOR].set_colorkey((255, 0, 255))
		self.images[Sprite.BLUE_DOOR] = pygame.image.load("art/door_blue.png").convert(self.screen)
		self.images[Sprite.BLUE_DOOR].set_colorkey((255, 0, 255))
		
	def main(self):
		while 1:
			for event in pygame.event.get():
				if event.type == pygame.QUIT: sys.exit()
				if event.type == pygame.KEYDOWN:
					if event.key == pygame.K_ESCAPE: sys.exit()
					if event.key == pygame.K_UP:
						if self.current_selection == self.loadlevel:
							self.current_selection = self.newgame = self.arial36.render("New Game", True, self.menu_highlight)
							self.loadlevel = self.arial36.render("Load Level", True, self.menu_normal)
						elif self.current_selection == self.quitgame:
							self.current_selection = self.loadlevel = self.arial36.render("Load Level", True, self.menu_highlight)
							self.quitgame = self.arial36.render("Quit Game", True, self.menu_normal)
					elif event.key == pygame.K_DOWN:
						if self.current_selection == self.newgame:
							self.current_selection = self.loadlevel = self.arial36.render("Load Level", True, self.menu_highlight)
							self.newgame = self.arial36.render("New Game", True, self.menu_normal)
						elif self.current_selection == self.loadlevel:
							self.current_selection = self.quitgame = self.arial36.render("Quit Game", True, self.menu_highlight)
							self.loadlevel = self.arial36.render("Load Level", True, self.menu_normal)
					elif event.key == pygame.K_RETURN:
						if self.current_selection == self.newgame: self.start()
						elif self.current_selection == self.loadlevel: self.promptlevel()
						elif self.current_selection == self.quitgame: self.quit()
			
			self.screen.fill(self.background)
			self.screen.blit(self.title, self.title_rect)
			self.screen.blit(self.newgame, self.newgame_rect)
			self.screen.blit(self.loadlevel, self.loadlevel_rect)
			self.screen.blit(self.quitgame, self.quitgame_rect)
			pygame.display.flip()
	
	def start(self):
		self.levelrenderer = LevelRenderer(self.images)
		self.levelrenderer.loadLevel("levels/Level1.txt")
		self.playgame()
		return
	
	def promptlevel(self):
		str = ""
		str_image = self.arial36.render(str, False, self.menu_highlight)
		str_rect = center(str_image, 360, self.size)
		while 1:
			self.screen.fill(self.background)
			self.screen.blit(self.title, self.title_rect)
			self.screen.blit(str_image, str_rect)
			pygame.display.flip()
			for event in pygame.event.get():
				if event.type == pygame.KEYDOWN:
					if event.key == pygame.K_1: str = str + "1"
					elif event.key == pygame.K_2: str = str + "2"
					elif event.key == pygame.K_3: str = str + "3"
					elif event.key == pygame.K_4: str = str + "4"
					elif event.key == pygame.K_5: str = str + "5"
					elif event.key == pygame.K_6: str = str + "6"
					elif event.key == pygame.K_7: str = str + "7"
					elif event.key == pygame.K_8: str = str + "8"
					elif event.key == pygame.K_9: str = str + "9"
					elif event.key == pygame.K_0: str = str + "0"
					elif event.key == pygame.K_ESCAPE: return
					elif event.key == pygame.K_RETURN:
						self.levelrenderer = LevelRenderer(self.images)
						self.levelrenderer.loadLevel("levels/Level" + str + ".txt")
						self.levelrenderer.levelnumber = int(str)
						return self.playgame()
					str_image = self.arial36.render(str, False, self.menu_highlight)
					str_rect = center(str_image, 360, self.size)
		return
	
	def quit(self):
		sys.exit()
	
	def renderBackground(self, gravity, background):
		ming = None
		maxg = None
		if DRAW_BACKGROUND == False:
			background.fill(self.background)
			return background
		self.screen.fill(self.background)
		self.screen.blit(self.title, self.title_rect)
		for x in xrange(0, 1024):
			if x % 8 == 0:
				self.screen.fill((255, 255, 0), (0, 360, x/2, 60))
			pygame.display.flip()
			for y in xrange(0, 768):
				g = gravity.grav_function(x, y)
				if ming == None:
					ming = g
				else:
					ming = min(ming, g)
				if maxg == None:
					maxg = g
				else:
					maxg = max(maxg, g)
		for x in xrange(0, 1024):
			if x % 8 == 0:
				self.screen.fill((255, 255, 0), (0, 360, 512+x/2, 60))
			pygame.display.flip()
			for y in xrange(0, 768):
				g = gravity.grav_function(x, y)
				if g<0:
					background.set_at((x, y), (255, 255-floor(fabs(255 * g / ming)), 255-floor(fabs(255 * g / ming))))
				elif g>0:
					background.set_at((x, y), (255-floor(fabs(255 * g / maxg)), 255-floor(fabs(255 * g / maxg)), 255))
				else:
					background.set_at((x, y), (255, 255, 255))
		return background
	
	def playgame(self):
		gravity = self.levelrenderer.level.gravity
		background = pygame.Surface(self.size)
		self.renderBackground(gravity, background)
		pos = self.levelrenderer.level.start
		self.player = Player(pos[0] * TILESIZE, pos[1] * TILESIZE, self.levelrenderer.level)
		self.level = self.levelrenderer.level
		while 1:
			if self.level is not self.levelrenderer.level:
				gravity = self.levelrenderer.level.gravity
				self.renderBackground(gravity, background)
				pos = self.levelrenderer.level.start
				self.player = Player(pos[0] * TILESIZE, pos[1] * TILESIZE, self.levelrenderer.level)
				self.level = self.levelrenderer.level
			for event in pygame.event.get():
				if event.type == pygame.KEYDOWN:
					if event.key == pygame.K_w or event.key == pygame.K_SPACE:
						if self.player.vy == 0:
							gravity_direction = self.level.gravity.grav_function(self.player.x, self.player.y)
							if gravity_direction>0:
								self.player.vy = -180
							else:
								self.player.vy = 180
					elif event.key == pygame.K_a:
						self.player.vx = -180
						self.player.facing_right = False
					elif event.key == pygame.K_d:
						self.player.vx = 180
						self.player.facing_right = True
					elif event.key == pygame.K_RETURN:
						if self.player.item is not None:
							obj = self.player.drop_item()
							self.levelrenderer.level.actors.append(obj)
						else:
							obj = self.player.pickup_item()
							if obj is not None:
								self.levelrenderer.level.actors.remove(obj)
					elif event.key == pygame.K_ESCAPE:
						return
				if event.type == pygame.KEYUP:
					if event.key == pygame.K_a or event.key == pygame.K_d:
						self.player.vx = 0
			self.player.update_location()
			self.screen.blit(background, (0, 0, 1024, 768))
			self.levelrenderer.render(self.screen)
			self.player.render(self.images, self.screen)
			#for actor in self.actors:
			#	actor.render(self.screen)
			pygame.display.flip()
		return

theGame = Game()
theGame.main()
