from actor import *
from sprite import *

class Key(Actor):
	"""Key class"""
	
	def __init__( self, x, y, level, door = None ):
		super( Key, self ).__init__( x, y, level, None )
		self.unlocked = False
		self.door = door
	
	def unlock( self ):
		self.unlocked = True
		if self.door is not None:
			self.door.open()
			
	def render(self, images, screen):
		screen.blit(images[Sprite.KEY], (self.x, self.y, TILESIZE, TILESIZE))
		
	def iskey(self):
		return True


